# Link all files from all required targets to specified export directory.
# Export directory may be outside MXP working directory.
# Linking preserves directory structure and is performed by "ln" (create hard links)
# if possible, otherwise -- bu "ln -s" (create symlinks).

echo "--  Export files:"

# Vaule of variable EXPORT_DIR must be a valid path.
# If path does not exist, new directory is created.
[ -n "$EXPORT_DIR" ]
exit_if_error "ERROR: variable EXPORT_DIR is not set."
if [ ! -e "$EXPORT_DIR" ]; then
    echo "-- Creating:  $EXPORT_DIR"
    mkdir -p "$EXPORT_DIR"
    exit_if_error "ERROR: failed to create export directory."
else
    echo "-- Using existing:  $EXPORT_DIR"
    [ -d "$EXPORT_DIR" ]
    exit_if_error "ERROR: path is not a directory."
fi

source $(mxp_locate_and_record_script link_functions.sh)

link_files -o $EXPORT_DIR $MXP_REQUIRED_TARGET_DIRS
