# Functions for link.sh.

# Parameters:
# Optional first paramter: -o -- overwrite destination files with newer source files
# $1 -- destination dir, $2 ... -- source dirs
link_files () {
    local overwrite=0
    if [ "$1" == "-o" ]; then overwrite=1; shift; fi
    local dest_dir=$1
    shift
    echo
    local nr_src=0  nr_skip=0  nr_ovr=0  nr_hard=0  nr_symb=0  nr_fail=0 
    echo "Linking files:"
    echo "     TO:  $dest_dir"
    while (($# > 0)); do
        local src_dir=$1
        shift
        echo "   FROM:  $src_dir"
        for f in $(find $src_dir -type f -printf '%P\n' | grep -v -e '^\.' -e '/\.' -e '^tmp/'); do
            ((nr_src++))
            if [ -e $dest_dir/$f ]; then
                if [ $src_dir/$f -nt $dest_dir/$f ]; then
                    if ((overwrite)); then
                        # we need explicitely remove destination
                        rm $dest_dir/$f 2> /dev/null
                        if (($? > 0)); then ((nr_fail++)); continue; fi
                        ((nr_ovr++))
                    else
                        ((nr_skip++)); continue
                    fi
                else
                    ((nr_skip++)); continue
                fi
            fi
            
            mkdir -p $(dirname $dest_dir/$f)
            if (($? > 0)); then ((nr_fail++)); continue; fi
            ln $src_dir/$f $dest_dir/$f 2> /dev/null
            if (($? > 0)); then
                ln -s $src_dir/$f $dest_dir/$f 2> /dev/null
                if (($? > 0)); then
                    ((nr_fail++))
                else
                    ((nr_symb++))
                fi
            else
                ((nr_hard++))
            fi
        done
    done
    printf "Done:  %'d total source files,  %'d skipped,  %'d overwritten;" $nr_src $nr_skip $nr_ovr 
    printf "  created:  %'d hardlinks,  %'d symlinks,  %'d failures.\n" $nr_hard $nr_symb $nr_fail
}
